OGRE: Ogre::QueuedRenderableCollection Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::QueuedRenderableCollection Class Reference

Lowest level collection of renderables. More...

`#include <OgreRenderQueueSortingGrouping.h>`

List of all members.

## Public Types

enum | OrganisationMode { OM_PASS_GROUP = 1, OM_SORT_DESCENDING = 2, OM_SORT_ASCENDING = 6 }
| Organisation modes required for this collection. More...

## Public Member Functions

| QueuedRenderableCollection ()
| ~QueuedRenderableCollection ()
void | clear (void)
| Empty the collection.
void | removePassGroup (Pass *p)
| Remove the group entry (if any) for a given Pass.
void | resetOrganisationModes (void)
| Reset the organisation modes required for this collection.
void | addOrganisationMode (OrganisationMode om)
| Add a required sorting / grouping mode to this collection when next used.
void | addRenderable (Pass *pass, Renderable *rend)
| Add a renderable to the collection using a given pass.
void | sort (const Camera *cam)
| Perform any sorting that is required on this collection.
void | acceptVisitor (QueuedRenderableVisitor *visitor, OrganisationMode om) const
| Accept a visitor over the collection contents.

## Protected Types

typedef std::vector< RenderablePass > | RenderablePassList
| Vector of RenderablePass objects, this is built on the assumption that vectors only ever increase in size, so even if we do clear() the memory stays allocated, ie fast.
typedef std::vector< Renderable * > | RenderableList
typedef std::map< Pass *, RenderableList *, PassGroupLess > | PassGroupRenderableMap
| Map of pass to renderable lists, this is a grouping by pass.

## Protected Member Functions

void | acceptVisitorGrouped (QueuedRenderableVisitor *visitor) const
| Internal visitor implementation.
void | acceptVisitorDescending (QueuedRenderableVisitor *visitor) const
| Internal visitor implementation.
void | acceptVisitorAscending (QueuedRenderableVisitor *visitor) const
| Internal visitor implementation.

## Protected Attributes

uint8 | mOrganisationMode
| Bitmask of the organisation modes requested.
PassGroupRenderableMap | mGrouped
| Grouped.
RenderablePassList | mSortedDescending
| Sorted descending (can iterate backwards to get ascending).

## Static Protected Attributes

static RadixSort< RenderablePassList, RenderablePass, uint32 > | msRadixSorter1
| Radix sorter for accessing sort value 1 (Pass).
static RadixSort< RenderablePassList, RenderablePass, float > | msRadixSorter2
| Radix sorter for sort value 2 (distance).

## Classes

struct | DepthSortDescendingLess
| Comparator to order objects by descending camera distance. More...
struct | PassGroupLess
| Comparator to order pass groups. More...
struct | RadixSortFunctorDistance
| Functor for descending sort value 2 for radix sort (distance). More...
struct | RadixSortFunctorPass
| Functor for accessing sort value 1 for radix sort (Pass). More...

## Detailed Description

Lowest level collection of renderables.

Remarks:
  To iterate over items in this collection, you must call the accept method and supply a QueuedRenderableVisitor. The order of the iteration, and whether that iteration is over a RenderablePass list or a 2-level grouped list which causes a visit call at the Pass level, and a call for each Renderable underneath.

Definition at line 108 of file OgreRenderQueueSortingGrouping.h.

## Member Typedef Documentation

typedef std::map<Pass*, RenderableList*, PassGroupLess> Ogre::QueuedRenderableCollection::PassGroupRenderableMap`[protected]`

| Map of pass to renderable lists, this is a grouping by pass. Definition at line 194 of file OgreRenderQueueSortingGrouping.h.

typedef std::vector<Renderable*> Ogre::QueuedRenderableCollection::RenderableList`[protected]`

| Definition at line 192 of file OgreRenderQueueSortingGrouping.h.

typedef std::vector<RenderablePass> Ogre::QueuedRenderableCollection::RenderablePassList`[protected]`

| Vector of RenderablePass objects, this is built on the assumption that vectors only ever increase in size, so even if we do clear() the memory stays allocated, ie fast. Definition at line 191 of file OgreRenderQueueSortingGrouping.h.

## Member Enumeration Documentation

enum Ogre::QueuedRenderableCollection::OrganisationMode

Organisation modes required for this collection.

Remarks:
  This affects the internal placement of the items added to this collection; if only one type of sorting / grouping is to be required, then renderables can be stored only once, whilst if multiple types are going to be needed then internally there will be multiple organisations. Changing the organisation needs to be done when the collection is empty.

Enumeration values:

  OM_PASS_GROUP | Group by pass.
  OM_SORT_DESCENDING | Sort descending camera distance.
  OM_SORT_ASCENDING | Sort ascending camera distance Note value overlaps with descending since both use same sort.

Definition at line 119 of file OgreRenderQueueSortingGrouping.h.

## Constructor & Destructor Documentation

Ogre::QueuedRenderableCollection::QueuedRenderableCollection | ( |  | ) |

Ogre::QueuedRenderableCollection::~QueuedRenderableCollection | ( |  | ) |

## Member Function Documentation

void Ogre::QueuedRenderableCollection::acceptVisitor | ( | QueuedRenderableVisitor * | visitor,
|  | OrganisationMode | om
| ) | const

Accept a visitor over the collection contents.

Parameters:

  | visitor | Visitor class which should be called back
  | om | The organisation mode which you want to iterate over. Note that this must have been included in an addOrganisationMode call before any renderables were added.

void Ogre::QueuedRenderableCollection::acceptVisitorAscending | ( | QueuedRenderableVisitor * | visitor | ) | const`[protected]`

| Internal visitor implementation.

void Ogre::QueuedRenderableCollection::acceptVisitorDescending | ( | QueuedRenderableVisitor * | visitor | ) | const`[protected]`

| Internal visitor implementation.

void Ogre::QueuedRenderableCollection::acceptVisitorGrouped | ( | QueuedRenderableVisitor * | visitor | ) | const`[protected]`

| Internal visitor implementation.

void Ogre::QueuedRenderableCollection::addOrganisationMode | ( | OrganisationMode | om | ) |

Add a required sorting / grouping mode to this collection when next used.

Remarks:
  You can only do this when the collection is empty.

See also:
  OrganisationMode

Definition at line 273 of file OgreRenderQueueSortingGrouping.h.

void Ogre::QueuedRenderableCollection::addRenderable | ( | Pass * | pass,
|  | Renderable * | rend
| ) |

| Add a renderable to the collection using a given pass.

void Ogre::QueuedRenderableCollection::clear | ( | void |  | ) |

| Empty the collection.

void Ogre::QueuedRenderableCollection::removePassGroup | ( | Pass * | p | ) |

Remove the group entry (if any) for a given Pass.

Remarks:
  To be used when a pass is destroyed, such that any grouping level for it becomes useless.

void Ogre::QueuedRenderableCollection::resetOrganisationModes | ( | void |  | ) |

Reset the organisation modes required for this collection.

Remarks:
  You can only do this when the collection is empty.

See also:
  OrganisationMode

Definition at line 263 of file OgreRenderQueueSortingGrouping.h.

void Ogre::QueuedRenderableCollection::sort | ( | const Camera * | cam | ) |

Perform any sorting that is required on this collection.

Parameters:

  | cam | The camera

## Member Data Documentation

PassGroupRenderableMap Ogre::QueuedRenderableCollection::mGrouped`[protected]`

| Grouped. Definition at line 233 of file OgreRenderQueueSortingGrouping.h.

uint8 Ogre::QueuedRenderableCollection::mOrganisationMode`[protected]`

| Bitmask of the organisation modes requested. Definition at line 230 of file OgreRenderQueueSortingGrouping.h.

RenderablePassList Ogre::QueuedRenderableCollection::mSortedDescending`[protected]`

| Sorted descending (can iterate backwards to get ascending). Definition at line 235 of file OgreRenderQueueSortingGrouping.h.

RadixSort<RenderablePassList, RenderablePass, uint32> Ogre::QueuedRenderableCollection::msRadixSorter1`[static, protected]`

| Radix sorter for accessing sort value 1 (Pass). Definition at line 206 of file OgreRenderQueueSortingGrouping.h.

RadixSort<RenderablePassList, RenderablePass, float> Ogre::QueuedRenderableCollection::msRadixSorter2`[static, protected]`

| Radix sorter for sort value 2 (distance). Definition at line 227 of file OgreRenderQueueSortingGrouping.h.

The documentation for this class was generated from the following file:

- OgreRenderQueueSortingGrouping.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:01 2008